UNIT mTSpielmanager;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mTRateZahlVerwalter, mTZahlenAusdenker, mTVersuchsZaehler;

//--------------------  ggf Uses-Liste einfgen !  --------------------
//uses ....;
//uses mTZahlenAusdenker ??
//uses mTRateZahlVerwalter ??
//uses mTZaehler ??

type
   TSpielmanager = CLASS

     // weitere Attribute
     private
        FBotschaft : string;
        RateZahlVerwalter : TRateZahlVerwalter;
        Zaehler : TVersuchsZaehler;
        ZahlenAusdenker : TZahlenAusdenker;

     //Objektbeziehungen:
        // hatTVersuchsZaehler : TVersuchsZaehler;
        // hatTZahlenAusdenker : TZahlenAusdenker;
        // hatTRateZahlVerwalter : TRateZahlVerwalter;

     // weitere Methoden
     private
        procedure SetBotschaft(s:string);
     public
        constructor Create;
        procedure neuesSpiel;
        procedure reagiere_auf_Tipp(r:integer);
        function GetBotschaft : string;
        function GetVersuche : integer;
        destructor destroy;

   end;

implementation

//+---------------------------------------------------------------------
//|         TSpielmanager: Methodendefinition 
//+---------------------------------------------------------------------

//-------- SetBotschaft (private) --------------------------------------
procedure TSpielmanager.SetBotschaft(s:string);
begin
  FBotschaft := s;
end;

//-------- Create (public) ---------------------------------------------
constructor TSpielmanager.Create;
begin
  inherited Create;
  RateZahlVerwalter := TRateZahlVerwalter.Create;
  Zaehler := TVersuchsZaehler.Create;
  ZahlenAusdenker := TZahlenAusdenker.Create;
  ZahlenAusdenker.neueZahl;
end;

//-------- neuesSpiel (public) -----------------------------------------
procedure TSpielmanager.neuesSpiel;
begin
  Zaehler.Reset;
  ZahlenAusdenker.neueZahl;
  SetBotschaft('');
end;

//-------- reagiere_auf_Tipp (public) ----------------------------------
procedure TSpielmanager.reagiere_auf_Tipp(r:integer);
var
  g : integer;
  b : string;
begin
  Zaehler.Inc;
  RateZahlVerwalter.SetZahl(r);
  g := ZahlenAusdenker.GetZahl;
  if r < g
  then
    b := 'RateZahl ist zu klein!'
  else
    if r > g
    then
      b := 'RateZahl ist zu gro!'
    else
      b := 'RateZahl = GeheimZahl!';
  SetBotschaft(b);
end;

//-------- GetBotschaft (public) ---------------------------------------
function TSpielmanager.GetBotschaft : string;
begin
  result := FBotschaft;
end;

//-------- GetVersuche (public) ----------------------------------------
function TSpielmanager.GetVersuche : integer;
begin
  result := Zaehler.GetZahl;
end;

//-------- destroy (public) --------------------------------------------
destructor TSpielmanager.destroy;
begin
  RateZahlVerwalter.Free;
  Zaehler.Free;
  ZahlenAusdenker.Free;
  inherited Destroy;
end;

end.
